//------------------------------------------------------------------------------
//  Matrix.cpp -   , Matrix
//------------------------------------------------------------------------------

#include "Matrix.h"

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  .
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

//  ""       
//   
void Matrix::Replace(int new_size)
{
	//  ,  new_size > _size
	if((new_size > _size) && (new_size > 0))
	{
		int new_len = new_size * new_size; //    
		FunPtr* tmp_fun_matr = new FunPtr[new_len];
		
		//    ""
		// (    )
		for(int i = 0; i < new_len; i++) tmp_fun_matr[i] = 0;

		//  ,     
		if(_fun_matr)
		{
			for(int i = 0; i < _size; i++) {
				for(int j = 0; j < _size; j++)
				{
					tmp_fun_matr[new_size*i + j] =_fun_matr[_size*i + j];
				}
			}
			//   
			delete[] _fun_matr;
		}
  	//      
		_fun_matr = tmp_fun_matr;
		_size = new_size; 
	}
}

namespace {
	//     
	inline int max(int a, int b)
	{
		return a > b ? a : b;
	}
} // namespace

//       ,  
//       
void Matrix::Insert(FunPtr fun, int i, int j)
{
	//  ( )  
	Replace(max(i, j)+1);
	//       	
	_fun_matr[_size*i + j] = fun;
}

//      
FunPtr Matrix::GetFun(int i, int j)
{
	return _fun_matr[_size*i + j];
}
