#ifndef __MatrixClass_h__
#define __MatrixClass_h__

//------------------------------------------------------------------------------
//  Matrix.h -  ,   
//   
//------------------------------------------------------------------------------

#include "NumberClass.h"

//     
typedef Number* (*FunPtr)(Number& n1, Number& n2);

class Matrix
{
public:
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	//  .
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

	//       ,  
	void Insert(FunPtr fun, int i, int j);

	//      
	FunPtr GetFun(int i, int j);

private:
  //  ""       
	//   
	void Replace(int new_size);

	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
public:
	//  
	Matrix(): _fun_matr(0), _size(0) {}

	// ,      
	~Matrix() {if(_fun_matr) delete[] _fun_matr;}
private:
	//      
	//   ( )
	FunPtr* _fun_matr;
	//   
	int _size;
};

#endif
