//------------------------------------------------------------------------------
//  SubDoubleDouble.cpp -    
//   
//------------------------------------------------------------------------------

#include "DoubleClass.h"
#include "Matrix.h"

//------------------------------------------------------------------------------
//       
Double& GetRegDouble();

//    
Matrix& GetSubtMatr();

//------------------------------------------------------------------------------
//       
Double* SubDoubleDouble(Double& n1, Double& n2)
{
	return new Double(n1._value - n2._value);
}

//------------------------------------------------------------------------------
//       .
//        ,
//     .
Number* SubDoubleDouble(Number& n1, Number& n2)
{
	Double* pDouble1;
	Double* pDouble2;
	//       
	if( (pDouble1 = dynamic_cast<Double*>(&n1)) &&
	    (pDouble2 = dynamic_cast<Double*>(&n2))	)
	{
		//    
		return SubDoubleDouble(*pDouble1, *pDouble2);
	}
	else
	{
		//   .   .
		return 0;
	}
}

//------------------------------------------------------------------------------
//       
//   

namespace {
	//   
	class regDoubleDouble
	{
	public:
		// ,   
		regDoubleDouble()
		{
			Double& regDouble = GetRegDouble();
		
			//       
			//      ()
			//   
			int Double_rank = regDouble.GetRank();

			Matrix& subtMatr = GetSubtMatr();
			subtMatr.Insert(SubDoubleDouble, Double_rank, Double_rank);
		}
	};

	//   
	regDoubleDouble DoubleDoubleFun;

} // namespace
//------------------------------------------------------------------------------
