//------------------------------------------------------------------------------
//  SubDoubleInt.cpp -    
//    ,    
//------------------------------------------------------------------------------

#include "IntClass.h"
#include "DoubleClass.h"

//  ()     
Double* SubIntDouble(Int& n1, Double& n2)
{
	return new Double(n1._value - n2._value);
}

//  ()     
Double* SubDoubleInt(Double& n1, Int& n2)
{
	return new Double(n1._value - n2._value);
}

//      .
//        ,
//     .
Number* SubIntDouble(Number& n1, Number& n2)
{
	Int* pInt1;
	Double* pDouble2;
	//       
	if( (pInt1 = dynamic_cast<Int*>(&n1)) &&
	    (pDouble2 = dynamic_cast<Double*>(&n2))	)
	{
		//    
		return SubIntDouble(*pInt1, *pDouble2);
	}
	else
	{
		//   .   .
		return 0;
	}

}

//      .
//        ,
//     .
Number* SubDoubleInt(Number& n1, Number& n2)
{
	Double* pDouble1;
	Int* pInt2;
	//       
	if( (pDouble1 = dynamic_cast<Double*>(&n1)) &&
	    (pInt2 = dynamic_cast<Int*>(&n2))	)
	{
		//    
		return SubDoubleInt(*pDouble1, *pInt2);
	}
	else
	{
		//   .   .
		return 0;
	}

}