//------------------------------------------------------------------------------
//  minus.cpp -  .
//------------------------------------------------------------------------------

#include "NumberClass.h"

//        
Number* SubIntInt(Number& n1, Number& n2);
//        
Number* SubIntDouble(Number& n1, Number& n2);
Number* SubDoubleInt(Number& n1, Number& n2);
Number* SubDoubleDouble(Number& n1, Number& n2);

//  
int const numbers = 2;

//     
typedef Number* (*SubFunPtr)(Number& n1, Number& n2);

//  
//static Number* (*subtMatr[numbers][numbers])(Number& n1, Number& n2) = 
static SubFunPtr subtMatr[numbers][numbers] = 
{
	//     
	SubIntInt,
	//     
	SubIntDouble, SubDoubleInt, SubDoubleDouble
};

//  ,   .
Number* operator- (Number& n1, Number& n2)
{
	SubFunPtr fun = subtMatr[n1.GetRank()][n2.GetRank()];
	if(fun) //    
		return fun(n1, n2);
	else
		return 0; //   
}


