//------------------------------------------------------------------------------
//  SubIntInt.cpp -      
//------------------------------------------------------------------------------

#include "IntClass.h"
#include "Matrix.h"

//------------------------------------------------------------------------------
//       
Int& GetRegInt();

//    
Matrix& GetSubtMatr();

//------------------------------------------------------------------------------
//  ()      
Int* SubIntInt(Int& n1, Int& n2)
{
	return new Int(n1._value - n2._value);
}

//------------------------------------------------------------------------------
//       .
//        ,
//     .
Number* SubIntInt(Number& n1, Number& n2)
{
	Int* pInt1;
	Int* pInt2;
	//       
	if( (pInt1 = dynamic_cast<Int*>(&n1)) &&
	    (pInt2 = dynamic_cast<Int*>(&n2))	)
	{
		//    
		return SubIntInt(*pInt1, *pInt2);
	}
	else
	{
		//   .   .
		return 0;
	}
}

//------------------------------------------------------------------------------
//       
//   

namespace {
	//   
	class regIntInt
	{
	public:
		// ,   
		regIntInt()
		{
			Int& regInt = GetRegInt();

			//       
			//      ()
			//   
			int Int_rank = regInt.GetRank();

			Matrix& subtMatr = GetSubtMatr();
			subtMatr.Insert(SubIntInt, Int_rank, Int_rank);
		}
	};

	//   
	regIntInt IntIntFun;

} // namespace
//------------------------------------------------------------------------------
