//------------------------------------------------------------------------------
//  minus.cpp -  .
//------------------------------------------------------------------------------

#include "IntClass.h"
#include "DoubleClass.h"

//  ,   RTTI.
Number* operator- (Number& n1, Number& n2)
{
	//   -  .
    if(Int* pInt1 = dynamic_cast<Int*>(&n1))
	{
		//   -  .
	    if(Int* pInt2 = dynamic_cast<Int*>(&n2))
		{
			return new Int(pInt1->GetValue() - pInt2->GetValue()); 
		}
		//   -  .
	    else if(Double* pDouble2 = dynamic_cast<Double*>(&n2))
		{
			return new Double(pInt1->GetValue() - pDouble2->GetValue()); 
		}
	}
	//   -  .
    else if(Double* pDouble1 = dynamic_cast<Double*>(&n1))
	{
		//   -  .
	    if(Int* pInt2 = dynamic_cast<Int*>(&n2))
		{
			return new Double(pDouble1->GetValue() - pInt2->GetValue()); 
		}
		//   -  .
	    else if(Double* pDouble2 = dynamic_cast<Double*>(&n2))
		{
			return new Double(pDouble1->GetValue() - pDouble2->GetValue()); 
		}
	}
}


